-----------------------------------------------------------------------------------------------------------
--[[
	NaW - Units Manager Class
    Copyright (C) 2011.
	Written by Roland Yonaba - E-mail: roland[dot]yonaba[at]gmail[dot]com
		
		This file Units behaviour
--]]
-----------------------------------------------------------------------------------------------------------

local require  = require
local ipairs = ipairs

local Utils = require 'Scripts/Utils/Unit'
local qoop = require 'Scripts/Libraries/qOOP'

local Unit = qoop.class()
local selected_units = {}
local Images = Utils.loadAllUnits('Images/Units/')

Unit:setMembers { x = 0, y = 0, w = 0, h = 0, health = 1,
				  move = false, selected = false, speed = 0,
				  img = nil}
				  

function Unit:setAbsolutePosition(x,y)
	self.x = x
	self.y = y
end


function Unit:setMapPosition(map,x,y)
	self.x = map.tileWidth * x - map.tileWidth
	self.y = map.tileHeight * y - map.tileHeight
end

function Unit:isVisible(map)	
	if  (self.health > 0) and ((map.mapX < self.x + self.w) and 
		(map.mapX + map.backgroundWidth > self.x) and 
		(map.mapY < self.y+self.h) and 
		(map.mapY + map.backgroundHeight > self.y)) then
		return true
	end
	return false
end

function Unit:drawAll(map,cursor)
	for i,unit in ipairs(self.all) do
		if unit:isVisible(map) then
			if cursor:isHovering(unit, map.mapX, map.mapY) and cursor:isDown('l') then
			unit.selected = true
			end
			if cursor:isDragging(unit, map.mapX, map.mapY) then
			unit.selected = true
			end
			love.graphics.draw(unit.img, unit.x - map.mapX, unit.y-map.mapY)
		end
	end
end

local Peasant = qoop.class(Unit)




return Unit